function u = projSimplex(f)
% projSimplexMatlab, project the rows of f onto the unit simplex 

N = size(f, 1);
L = size(f, 2);

y = sort(f, 2, 'descend');
tmpsum = zeros(N, 1);
active = logical(ones(N, 1));
for ii=1:L-1
    tmpsum(active) = tmpsum(active) + y(active, ii);
    tmax(active) = (tmpsum(active) - 1)/ii;
    active = (tmax' < y(:, ii + 1));
end
tmax(active) = (tmpsum(active) + y(active, L) - 1) / L;
u = max(reshape(f, [N L]) - repmat(tmax', 1, L), 0);

end